"""
Django settings for rhl project.

Generated by 'django-admin startproject' using Django 4.2.5.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.2/ref/settings/
"""

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import os

from .utils import (
    get_env,
    string_to_bool,
    string_to_list,
)

PROJECT_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
BASE_DIR = os.path.dirname(PROJECT_DIR)


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.2/howto/deployment/checklist/


# Application definition

INSTALLED_APPS = [
    "home",
    "base",
    "sponsors",
    "search",
    "wagtail.contrib.forms",
    "wagtail.contrib.redirects",
    "wagtail.embeds",
    "wagtail.sites",
    "wagtail.users",
    "wagtail.snippets",
    "wagtail.documents",
    "wagtail.images",
    "wagtail.search",
    "wagtail.admin",
    "wagtail.contrib.settings",
    "wagtail.contrib.table_block",
    "wagtail",
    "modelcluster",
    "taggit",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
]

MIDDLEWARE = [
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "wagtail.contrib.redirects.middleware.RedirectMiddleware",
]

ROOT_URLCONF = "rhl.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [
            os.path.join(PROJECT_DIR, "templates"),
        ],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                'wagtail.contrib.settings.context_processors.settings',
            ],
        },
    },
]

WSGI_APPLICATION = "rhl.wsgi.application"


# Database
# https://docs.djangoproject.com/en/4.2/ref/settings/#databases

# Get the database engine name
RHL_DATABASE_ENGINE = get_env('RHL_DATABASE_ENGINE', 'sqlite')

# If selected engine is Postgres SQL
if RHL_DATABASE_ENGINE in ['postgresql', 'postgres']:
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': get_env('RHL_DATABASE_PG_BASE_NAME', 'rhl'),
            'USER': get_env('RHL_DATABASE_PG_USER', 'rhl'),
            'PASSWORD': get_env('RHL_DATABASE_PG_PASSWORD', ''),
            'HOST': get_env('RHL_DATABASE_PG_HOST', '127.0.0.1'),
            'PORT': get_env('RHL_DATABASE_PG_PORT', '5432'),
        }
    }

# If selected engine is sqlite or unknown
else:
    DATABASES = {
        "default": {
            "ENGINE": "django.db.backends.sqlite3",
            "NAME": get_env(
                'RHL_DATABASE_SQLITE_PATH',
                os.path.join(BASE_DIR, "db.sqlite3")
            ),
        }
    }


# Password validation
# https://docs.djangoproject.com/en/4.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

# Models config
DEFAULT_AUTO_FIELD='django.db.models.AutoField'

# Images config
WAGTAILIMAGES_EXTENSIONS = ["gif", "jpg", "jpeg", "png", "webp", "svg"]

# Internationalization
# https://docs.djangoproject.com/en/4.2/topics/i18n/

LANGUAGE_CODE = get_env('RHL_LANGUAGE_CODE', 'fr-ch')

TIME_ZONE = get_env('RHL_TIME_ZONE', 'Europe/Zurich')

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.2/howto/static-files/

STATICFILES_FINDERS = [
    "django.contrib.staticfiles.finders.FileSystemFinder",
    "django.contrib.staticfiles.finders.AppDirectoriesFinder",
]

STATICFILES_DIRS = [
    os.path.join(PROJECT_DIR, "static"),
]

# ManifestStaticFilesStorage is recommended in production, to prevent outdated
# JavaScript / CSS assets being served from cache (e.g. after a Wagtail upgrade).
# See https://docs.djangoproject.com/en/4.2/ref/contrib/staticfiles/#manifeststaticfilesstorage
STATICFILES_STORAGE = "django.contrib.staticfiles.storage.ManifestStaticFilesStorage"

STATIC_ROOT = get_env(
    'RHL_STATIC_ROOT',
    os.path.join(BASE_DIR, "static"),
)
STATIC_URL = get_env('RHL_STATIC_URL', '/static/')

MEDIA_ROOT = get_env(
    'RHL_MEDIA_ROOT',
    os.path.join(BASE_DIR, "media"),
)
MEDIA_URL = get_env('RHL_MEDIA_URL', '/media/')


# Email settings

# Set default email address to use in the "from" field
DEFAULT_FROM_EMAIL = get_env(
    'RHL_DEFAULT_FROM_EMAIL',
    '',
)

# Get e-mail backend, only smtp and console for now
choosed_email_backend = get_env(
    'RHL_EMAIL_BACKEND',
    'console',
)

if choosed_email_backend == 'smtp':
    # Use SMTP backend
    EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'
    EMAIL_HOST = get_env(
        'RHL_EMAIL_HOST',
        'localhost',
    )
    EMAIL_PORT = get_env(
        'RHL_EMAIL_PORT',
        25,
    )
    EMAIL_USE_TLS = string_to_bool(
        get_env(
            'RHL_EMAIL_USE_TLS',
            'False',
        )
    )
    EMAIL_USE_SSL = string_to_bool(
        get_env(
            'RHL_EMAIL_USE_SSL',
            'False',
        )
    )
    EMAIL_HOST_USER = get_env(
        'RHL_EMAIL_HOST_USER',
        '',
    )
    EMAIL_HOST_PASSWORD = get_env(
        'RHL_EMAIL_HOST_PASSWORD',
        '',
    )

else:
    # Print the sent emails on the stdout
    EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'


# Wagtail settings

WAGTAIL_SITE_NAME = "rhl"

# Search
# https://docs.wagtail.org/en/stable/topics/search/backends.html
WAGTAILSEARCH_BACKENDS = {
    "default": {
        "BACKEND": "wagtail.search.backends.database",
    }
}

# Base URL to use when referring to full URLs within the Wagtail admin backend -
# e.g. in notification emails. Don't include '/admin' or a trailing slash
WAGTAILADMIN_BASE_URL = get_env(
    'WAGTAILADMIN_BASE_URL',
    'http://example.com',
)


# Gravatar settings

WAGTAIL_GRAVATAR_PROVIDER_URL = None

# Datetime

# User for e-mail formated from a form
SHORT_DATE_FORMAT = "Y/m/d"
SHORT_DATETIME_FORMAT = "Y/m/d G:i"


# Format help for the date and datetime field if a form
DATE_PREFERED_FORMAT = "Année-mois-jour"
DATETIME_PREFERED_FORMAT = "Année-mois-jour heures:minutes"
